// hash table for integers

import java.util.ArrayList;

class intHash {

    private int htablesize = 101;
    private Cell[] htable; 

    public intHash(int size) {
	    htablesize = size;
	    htable = new Cell[htablesize];
	    for (int i=0; i<htablesize; i++) htable[i] = null;
    }

    public void add(int s) {
	    int h = hash(s);
	    htable[h] = new Cell(s, htable[h]);	// what does this do?
    }

    public boolean isMember(int s) {
	    int h = hash(s);
	    Cell p = htable[h];
	    while (p!=null) {
		    if (s == p.getValue()) return true;
		    p = p.next();
	    }
	    return false;
    }

    public void print() {
	for (int i = 0; i<htablesize; i++) {
	    Cell p = htable[i];
	    while (p!= null) {
		    System.out.println(p.getValue());
		    p = p.next();
	    }
	}
    }

    public int hash(int s) {
	    //int h = s.hashCode() % htablesize;
	    int h = s % htablesize;
	    if (h<0) h+= htablesize;	// stupid negative numbers
	    return h;
    }

    public class Cell {
	private int s_;
	private Cell  next_;
	public Cell(int s, Cell n) {s_ = s; next_ = n;}
	public int getValue() {return s_;}
	public Cell   next() {return next_;}
        public void setValue(int s) {s_ = s;}
        public void setNext(Cell c)   {next_ = c;}
    }	
}

